/*==========================================================================
//  Dcryptage du chiffrement de Vigenre
//  Projet TER, Matrise d'Informatique 1997,
//  Universit de Bordeaux 1, France,
//  Tous droits rservs.
//
//  de Maillard Luc, Montiton Frdric
//  Morreeuw Jean-Franois et Lompo Issa
//
//  mailto:morreeuw@emi.u-bordeaux.fr,dbv@komicom.remcomp.fr
//  http://www.emi.u_bordeaux.fr/~morreeuw/universite/TER
//
//  INTERFACE DU MODULE DU TEST DE FRIEDMAN (INDICE COINCIDENCE)
//
//========================================================================*/

#include <stdlib.h>
#include <stdio.h>
#include "ic.h"
#include "option.h"

static char *version="04/03/1997";
static char *option[]={"-h", "--help",
                       "-v", "--version",
                       "-c", "--cycle",
                       "-f", "--infile", NULL };
static int choice[]={1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6};
static char *usage[]={"[-v] [-h] [-f FILENAME] [-c LENGTH]", NULL,
                      "Coincidence value of a file", "",
                      "  -f --infile    choose the file to analyse (default is STDIN)",
                      "  -c --cycle     choose the cycle of the analyse (default is 1)",
                      "  -h --help      display this help",
                      "  -v --version   output version information", NULL};

/*========================================================================*/

void
main(int argc, char **argv)
{
  char *name = argv[0];
  char *file_in = NULL;
  long cycle = 1;

  while(*(++argv))
    switch(opt_argument(*argv, option, choice))
      {
      case 1:
        opt_usage(name, usage);
        exit(0);
        break;
      case 2:
        opt_version(name, version);
        exit(0);
        break;
      case 3:
        if(*(++argv))
          {
            cycle = atoi(*argv);
            cycle = (cycle>0)?cycle:1;
          }
        else
          opt_xusage(name, usage);
        break;
      case 4:
        if(*(++argv))
          file_in = *argv;
        else
          opt_xusage(name, usage);
        break;
      default:
        opt_xusage(name, usage);
      }

  {
    double result = 0;
    char *data = NULL;
    long length = opt_filter(file_in, &data);
    result = ic_coincide(data, length, cycle);
    printf("%.15g\n", result);
    free2(data);
  }

  exit(0);
}

/*========================================================================*/
