/*==========================================================================
//  Dcryptage du chiffrement de Vigenre
//  Projet TER, Matrise d'Informatique 1997,
//  Universit de Bordeaux 1, France,
//  Tous droits rservs.
//
//  de Maillard Luc, Montiton Frdric
//  Morreeuw Jean-Franois et Lompo Issa
//
//  mailto:morreeuw@emi.u-bordeaux.fr,dbv@komicom.remcomp.fr
//  http://www.emi.u_bordeaux.fr/~morreeuw/universite/TER
//
//  MODULE D'ANALYSE FREQUENTIELLE DYNAMIQUE
//
//========================================================================*/

#include <stdlib.h>
#include <stdio.h>
#include "count.h"

#define COUNT_BUFFER_SIZE 1024

/*==========================================================================
//  Enregistre dans une structure 'set' les suites de step-lettres
//========================================================================*/

set
count_compute(char *data, long length, int step, int distance, int start)
{
  int i, j;
  set set = set_create(SET_STRING);
  char key_map[COUNT_BUFFER_SIZE+1];
  char *key;

  if(step>COUNT_BUFFER_SIZE)
    key = (char *) malloc2((step+1)*sizeof(*key));
  else
    key = key_map;
  
  key[step]='\0';

  VERIFY(data);

  for(i=start; i<=length-step; i+=distance)
    {
      for(j=0; j<step; j++)
        key[j]=data[i+j];
      set_insert(set, key);
    }

  if(key != key_map)
    free2(key);
  return set;
}

/*========================================================================*/
