/*==========================================================================
//  Dcryptage du chiffrement de Vigenre
//  Projet TER, Matrise d'Informatique 1997,
//  Universit de Bordeaux 1, France,
//  Tous droits rservs.
//
//  de Maillard Luc, Montiton Frdric
//  Morreeuw Jean-Franois et Lompo Issa
//
//  mailto:morreeuw@emi.u-bordeaux.fr,dbv@komicom.remcomp.fr
//  http://www.emi.u_bordeaux.fr/~morreeuw/universite/TER
//
//  INTERFACE DU MODULE DE RECHERCHE DES REPETITIONS
//
//========================================================================*/

#include <stdlib.h>
#include <stdio.h>
#include "search.h"
#include "option.h"

static char *version="04/06/1997";
static char *option[]={"-h", "--help",
                       "-v", "--version",
                       "-s", "--step",
                       "-f", "--infile",
                       "-b", "--buffer",
                       "-d", "--depth", NULL };
static int choice[]={1, 1, 2, 2, 3, 3, 4, 4, 6, 6, 7, 7};
static char *usage[]={"[-v] [-h] [-f FILENAME] [-s STEP] [-b BUFFER] [-d DEPTH]", NULL,
                      "Search some cycles in a file", "",
                      "  -f --infile    choose the file to analyse (default is STDIN)",
                      "  -s --step      choose the step of the search (default is 3)",
                      "  -b --buffer    choose the length of the search (default is 2048)",
                      "  -d --depth     choose the depth of the search (default is 10)",
                      "  -h --help      display this help",
                      "  -v --version   output version information", NULL};

/*========================================================================*/

void
main(int argc, char **argv)
{
  char *name = argv[0];
  char *file_in = NULL;
  int step = 3;
  int buffer = 2048;
  int depth = 10;

  while(*(++argv))
    switch(opt_argument(*argv, option, choice))
      {
      case 1:
        opt_usage(name, usage);
        exit(0);
        break;
      case 2:
        opt_version(name, version);
        exit(0);
        break;
      case 3:
        if(*(++argv))
          {
            step = atoi(*argv);
            step = (step>0)?step:1;
          }
        else
          opt_xusage(name, usage);
        break;
      case 4:
        if(*(++argv))
          file_in = *argv;
        else
          opt_xusage(name, usage);
        break;
      case 6:
        if(*(++argv))
          {
            buffer = atoi(*argv);
            buffer = (buffer>0)?buffer:2048;
          }
        else
          opt_xusage(name, usage);
        break;
      case 7:
        if(*(++argv))
          {
            depth = atoi(*argv);
            depth = (depth>0)?depth:10;
          }
        else
          opt_xusage(name, usage);
        break;
      default:
        opt_xusage(name, usage);
      }

  {
    result_p result = NULL;
    char *data = NULL;
    long length = opt_load(file_in, &data);

    result = search_key_length(data, length, step, buffer, depth);
    result_view(result);
    result_destroy(result);

    free(data);
  }

  exit(0);
}

/*========================================================================*/
