/*==========================================================================
//  Module de skiplist permettant un acces par chainage ou par cle. Ce
//  module est une version legerement modifiee du module realise pour le
//  projet de licence LMI en 1996.
//========================================================================*/

#ifndef DSL_H
#define DSL_H

typedef struct dsl *dsl;

/*==========================================================================
//  comparefun(a,b)=1 <=> a<b
//  comparefun(a,b)=0 <=> a>=b
//========================================================================*/

extern dsl   dsl_create(int (*comparefun)(void *, void *));
extern void  dsl_destroy(dsl head);
extern int   dsl_member(dsl head, void *key);
extern void *dsl_find(dsl head, void *key);
extern void *dsl_next(dsl head, void *key);
extern void  dsl_insert(dsl head, void *key, void *value);
extern void  dsl_delete(dsl head, void *key);

#endif
