/*==========================================================================
//  Dcryptage du chiffrement de Vigenre
//  Projet TER, Matrise d'Informatique 1997,
//  Universit de Bordeaux 1, France,
//  Tous droits rservs.
//
//  de Maillard Luc, Montiton Frdric
//  Morreeuw Jean-Franois et Lompo Issa
//
//  mailto:morreeuw@emi.u-bordeaux.fr,dbv@komicom.remcomp.fr
//  http://www.emi.u_bordeaux.fr/~morreeuw/universite/TER
//
//  INTERFACE HTML DES MODULES DE CHIFFRAGE/DECRYPTAGE
//
//========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "util.h"
#include "auto.h"
#include "cipher.h"
#include "xcept.h"

#define MAX_ENTRIES 256

static char *filter(char *string);
static void  printfn(char *string, int size);

static char *password1 = NULL;
static char *password2 = NULL;
static char *window1 = NULL;
static char *window2 = NULL;
static char *command = "formatter";
static char *windowfrom = "1";
static char *windowdest = "2";
static int   windowfromnum = 1;
static int   windowdestnum = 2;

void
main(int argc, char *argv[]) 
{
  entry entries[MAX_ENTRIES];
  int i;
  int cl;
  int number;

  printf("Content-type: text/html%c%c",10,10);

  if(strcmp(getenv("REQUEST_METHOD"),"POST")!=0) 
    {
      printf("This script should be referenced with a METHOD of POST%c",10);
      exit(1);
    }
  if(strcmp(getenv("CONTENT_TYPE"),"application/x-www-form-urlencoded")) 
    {
      printf("This script can only be used to decode form results%c",10);
      exit(1);
    }

  cl = atoi(getenv("CONTENT_LENGTH"));
  
 
  for(i=0; cl && (!feof(stdin)); i++) 
    {
      entries[i].val = fmakeword(stdin, '&', &cl);    /* lecture d'un mot */
      plustospace(entries[i].val);                    /* enlevement de + */
      unescape_url(entries[i].val);                   /* full ascii */
      entries[i].name = makeword(entries[i].val,'='); /* splitter */
    }
   
  /* A ce niveau, i contient le nombre effectif de variables
     disponibles, et entries[] leurs noms+valeurs. On peut maintenant
     les utiliser pour la suite du programme. */

  number=i;
  
  for(i=0; i<number; i++)
    {
      if(strcmp(entries[i].name, "window1")==0)
        window1=entries[i].val;
      if(strcmp(entries[i].name, "window2")==0)
        window2=entries[i].val;
      if(strcmp(entries[i].name, "password1")==0)
        password1=entries[i].val;
      if(strcmp(entries[i].name, "password2")==0)
        password2=entries[i].val;
      if(strcmp(entries[i].name, "windowfrom")==0)
        windowfrom=entries[i].val;
      if(strcmp(entries[i].name, "windowdest")==0)
        windowdest=entries[i].val;
      if(strcmp(entries[i].name, "command")==0)
	command=entries[i].val;
    }

  /* Les variables ont ete mises a jour et doivent etre utilisees par
     le programme de chiffrement/dechiffrement. Le resultat doit etre
     de nouveau enregistre puis affiche. */

  password1 = filter(password1);
  password2 = filter(password2);
  window1 = filter(window1);
  window2 = filter(window2);

  if(strcmp(windowfrom, "2")==0)
    windowfromnum = 2;
  if(strcmp(windowdest, "1")==0)
    windowdestnum = 1;
  
  {
    char *data = windowfromnum==1?window1:window2;
    char *pass = windowfromnum==1?password1:password2;
    char *newdata = windowdestnum==1?window1:window2;
    char *newpass = windowdestnum==1?password1:password2;
    
    if(strcmp(command, "Dcrypter")==0)
      {
        HANDLE(fatal_XCEPT, auto_install("."), printf("%s", xcept_format()));
        HANDLE(fatal_XCEPT, newpass = *auto_decipher(data, strlen(data), 20, 15),
	           printf("%s", xcept_format()));
        auto_remove();
      }    

    if(strcmp(command, "Chiffrer")==0)
      {
	newpass = "";
	newdata = cipher_compute(pass, data, strlen(data), 1);
      }
   if(strcmp(command, "Dchiffrer")==0)
     {
       newpass = "";
       newdata = cipher_compute(pass, data, strlen(data), -1);
     }
   
    if(windowdestnum==1)
      {
	window1 = newdata;
	password1 = newpass;
      }
    else
      {
	window2 = newdata;
	password2 = newpass;
      }
  }
  
  printf("<HTML><HEAD><TITLE>TER Decipher GUI</TITLE></HEAD>");
  printf("<BODY BGCOLOR=#FFFFFF TEXT=#000081 LINK=#005000 VLINK=#005000 ALINK=#00AA55>");
  printf("<TABLE><TR><TD ALIGN=CENTER><A HREF=\"index.html\">");
  printf("<IMG SRC=\"bdx1-logo.gif\" ALT=\"back\"");
  printf("BORDER=0></A><BR><I><SMALL>25 avril 1997</SMALL></I></TD> <TD ALIGN=CENTER>");
  printf("<H1>Exp&eacute;rimentation du d&eacute;cryptage</H1></TD></TR><TR><TD></TD><TD>");
  printf("<CENTER>");
  printf("<FORM ACTION=\"experiment.cgi\" METHOD=POST>");

  printf("<TABLE BORDER=0 CELLPADDING=10><TR><TD>");
  printf("<INPUT TYPE=TEXT NAME=password1 SIZE=16 MAXLENGTH=256 VALUE=\"%s\">", password1);
  printf("<BR><SMALL>longueur %d</SMALL>", strlen(password1));
  printf("</TD><TD><I><B><BIG>Fen&ecirc;tre 1</BIG></B></I>");
  printf("</TD><TD>");
  printf("<INPUT TYPE=TEXT NAME=password2 SIZE=16 MAXLENGTH=256 VALUE=\"%s\">", password2);
  printf("<BR><SMALL>longueur %d</SMALL>", strlen(password2));
  printf("</TD><TD><I><B><BIG>Fen&ecirc;tre 2</BIG></B></I></TR><TR><TD COLSPAN=2>");
  printf("<TEXTAREA ROWS=8 COLS=30 NAME=window1>");
  printfn(window1, 30);
  printf("</TEXTAREA>");
  printf("<BR><SMALL>longueur %d</SMALL>", strlen(window1));
  printf("</TD><TD COLSPAN=2>");
  printf("<TEXTAREA ROWS=8 COLS=30 NAME=window2>");
  printfn(window2, 30);
  printf("</TEXTAREA>");
  printf("<BR><SMALL>longueur %d</SMALL>", strlen(window2));
  printf("</TD></TR><TR><TD COLSPAN=2 ALIGN=CENTER>");

  printf("<SELECT NAME=command>");
  printf("<OPTION>Formater<OPTION>Chiffrer<OPTION>D&eacute;chiffrer<OPTION>D&eacute;crypter");
  printf("</SELECT>de");
  printf("<SELECT NAME=windowfrom><OPTION %s>1<OPTION %s>2</SELECT>vers",
	 windowfromnum==1?"SELECTED":"", windowfromnum==2?"SELECTED":"");
  printf("<SELECT NAME=windowdest><OPTION %s>1<OPTION %s>2</SELECT>",
	 windowdestnum==1?"SELECTED":"", windowdestnum==2?"SELECTED":"");

  printf("</TD><TD COLSPAN=2 ALIGN=CENTER><INPUT TYPE=RESET VALUE=\"Annuler\">");
  printf("<INPUT TYPE=SUBMIT VALUE=\"Ex&eacute;cuter\"></TD></TR></TABLE>");
  printf("</FORM>");
  printf("</CENTER></TD></TR></TABLE>");
  printf("<FONT SIZE=-2><I>Tous droits r&eacute;serv&eacute;s &copy; 1997,");
  printf("<A HREF=\"mailto:morreeuw@emi.u-bordeaux.fr\">morreeuw</A>,");
  printf("LM<SUP>3</SUP>.</I></FONT><BR><FONT SIZE=-1>");
  printf("<I>Derni&egrave;re r&eacute;vision :</I> 25 avril 1997.</FONT>");
  printf("</BODY></HTML>");
  
  exit(0);
}

char *
filter(char *string)
{
  char *newstring = NULL;
  int length = 0;
  int i, j;

  if(string==NULL)
    return "";
  length = strlen(string);
  newstring = (char *) malloc(length+1);
  newstring[length]='\0';
  for(i=0, j=0; i<length; i++)
    {
      if(string[i]>='A' && string[i]<='Z')
	newstring[j++]=string[i];
      else if(string[i]>='a' && string[i]<='z')
	newstring[j++]=string[i]-'a'+'A';
      else switch(string[i])
	{
	case '':
	case '':
	case '':
	case '':
	  newstring[j++]='I';
	  break;
	case '':
	case '':
	case '':
	case '':
	  newstring[j++]='E';
	  break;
	case '':
	case '':
	case '':
	case '':
	  newstring[j++]='A';
	  break;
	case '':
	case '':
	case '':
	case '':
	  newstring[j++]='O';
	  break;
	case '':
	case '':
	case '':
	case '':
	  newstring[j++]='U';
	  break;
	case '':
	case '':
	  newstring[j++]='Y';
	  break;
	case '':
	  newstring[j++]='C';
	  break;
	default:
	  break;
	}
    }
  newstring[j]='\0';
  return newstring;
}

void
printfn(char *string, int size)
{
  char buffer[65];
  int length = strlen(string);
  int i;
  buffer[size]='\0';
  
  for(i=0; i<length; i+=size)
    {
      memset(buffer, '\0', 65);
      strncpy(buffer, (const char *) string+i, length-i<size?length-i:size);
      printf("%s\n", buffer);
    }
  return;
}
