/*==========================================================================
//  Module de calcul de l'indice de coincidence
//   1. ic_coincide()   calcule l'indice pour une longueur de cle donnee
//   2. ic_frequency()  retourne une table de frequences
//   3. ic_compute()    idem mais ne se charge pas d'allouer le tableau
//   4. ic_value()      calcule l'indice d'un tableau
//   5. ic_mutual()     indice mutuel entre 2 tableaux modulo un decalage
//========================================================================*/

#ifndef IC_H
#define IC_H

#include "define.h"

extern double  ic_coincide(char *data, long length, short cycle);
extern double *ic_frequency(char *data, long length, short cycle, short start, short width);
extern void    ic_compute(double *table, short width, char *data, long length, short cycle, short start);
extern double  ic_value(double *table, short width);
extern double  ic_mutual(double *table1, double *table2, short width, int shift);

#endif
