/*==========================================================================
//  Dcryptage du chiffrement de Vigenre
//  Projet TER, Matrise d'Informatique 1997,
//  Universit de Bordeaux 1, France,
//  Tous droits rservs.
//
//  de Maillard Luc, Montiton Frdric
//  Morreeuw Jean-Franois et Lompo Issa
//
//  mailto:morreeuw@emi.u-bordeaux.fr,dbv@komicom.remcomp.fr
//  http://www.emi.u_bordeaux.fr/~morreeuw/universite/TER
//
//  MODULE D'ACCES AUX FICHIERS
//
//========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

#if !(__dest_os) || __dest_os != __be_os
#include <unistd.h>
#endif

#include "io.h"

#define BUFFER_SIZE 1024

/*========================================================================*/

int
io_open(char *filename, int mode)
{
  if(!filename)
    return ((mode&O_WRONLY)==O_WRONLY)?STDOUT_FILENO:STDIN_FILENO;

  if(strcmp(filename, "stdin")==0)
    return STDIN_FILENO;
  else if(strcmp(filename, "stdout")==0)
    return STDOUT_FILENO;
  else
    return open(filename, mode, 0644);
}

/*========================================================================*/

int
io_read(int fd, char **data)
{
  int buffer = BUFFER_SIZE;
  int size = 0;

  while(buffer == BUFFER_SIZE)
    {
      if(*data)
        *data = (char *) realloc2((void *) *data, (size+=BUFFER_SIZE)+1);
      else
        *data = (char *) malloc2((size=BUFFER_SIZE)+1);
      buffer = read(fd, &(*data)[size-BUFFER_SIZE], BUFFER_SIZE);
    }
  size+=(buffer-BUFFER_SIZE);
  (*data)[size]='\0';
  return size;
}

/*========================================================================*/

int
io_write(int fd, char *data, size_t length)
{
  if(fd==-1)
    return -1;
  else
    return write(fd, data, length);
}

/*========================================================================*/
