/*==========================================================================
//  Dcryptage du chiffrement de Vigenre
//  Projet TER, Matrise d'Informatique 1997,
//  Universit de Bordeaux 1, France,
//  Tous droits rservs.
//
//  de Maillard Luc, Montiton Frdric
//  Morreeuw Jean-Franois et Lompo Issa
//
//  mailto:morreeuw@emi.u-bordeaux.fr,dbv@komicom.remcomp.fr
//  http://www.emi.u_bordeaux.fr/~morreeuw/universite/TER
//
//  MODULE D'ALLOCATION UTILISANT LES EXCEPTIONS
//
//========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "malloc2.h"

DEFINE_XCEPT(malloc_XCEPT);

/*------------------------------------------------------------------------*/

void *
malloc2(long size)
{
  void *pointer = malloc(size);
  if(pointer==NULL)
    {
      char string[20];
      char *newstring = NULL;

      sprintf(string, "malloc(%d)", (int) size);
      newstring = strdup(string);
      if(newstring==NULL)
        newstring = "malloc";
      RAISE(malloc_XCEPT, newstring, "Insuffisant memory");
    }
  return pointer;
}

/*------------------------------------------------------------------------*/

void
free2(void *pointer)
{
  free(pointer);
  return;
}

/*------------------------------------------------------------------------*/

char *
strdup2(char *string)
{
  char *newstring;

  VERIFY(string);
  newstring = strdup(string);
  if(string==NULL)
    RAISE(malloc_XCEPT, "strdup", "Insuffisant memory");
  return newstring;
}

/*------------------------------------------------------------------------*/

void *
realloc2(void *pointer, long size)
{
  void *new_pointer;
  
  VERIFY(pointer);
  new_pointer = realloc(pointer, size);
  if(new_pointer==NULL)
    {
      char string[20];
      char *newstring = NULL;

      sprintf(string, "realloc(%d)", (int) size);
      newstring = strdup(string);
      if(newstring==NULL)
        newstring = "realloc";
      RAISE(malloc_XCEPT, newstring, "Insuffisant memory");
    }
  return new_pointer;
}

/*------------------------------------------------------------------------*/
