/*==========================================================================
//  Dcryptage du chiffrement de Vigenre
//  Projet TER, Matrise d'Informatique 1997,
//  Universit de Bordeaux 1, France,
//  Tous droits rservs.
//
//  de Maillard Luc, Montiton Frdric
//  Morreeuw Jean-Franois et Lompo Issa
//
//  mailto:morreeuw@emi.u-bordeaux.fr,dbv@komicom.remcomp.fr
//  http://www.emi.u_bordeaux.fr/~morreeuw/universite/TER
//
//  INTERFACE DU MODULE DE RECHERCHE DES DECALAGES RELATIFS (KERCKHOFF)
//
//========================================================================*/

#include <stdlib.h>
#include <stdio.h>
#include "kh.h"
#include "option.h"

#define MINTER_DEPTH_MAX 150

static char *version="04/06/1997";
static char *option[]={"-h", "--help",
                       "-v", "--version",
                       "-f", "--infile",
                       "-d", "--depth", NULL };
static int choice[]={1, 1, 2, 2, 3, 3, 4, 4};
static char *usage[]={"[-v] [-h] [-f FILENAME] [-d DEPTH] CYCLE", NULL,
                      "Search some rules in a file", "",
                      "  -f --infile    choose the file to analyse (default is STDIN)",
                      "  -d --depth     choose the depth of the search (default is 10)",
                      "  -h --help      display this help",
                      "  -v --version   output version information", NULL};

/*========================================================================*/

void
main(int argc, char **argv)
{
  char *name = argv[0];
  char *file_in = NULL;
  int depth = 10;
  int cycle = 0;

  while(*(++argv))
    switch(opt_argument(*argv, option, choice))
      {
      case 1:
        opt_usage(name, usage);
        exit(0);
        break;
      case 2:
        opt_version(name, version);
        exit(0);
        break;
      case 3:
        if(*(++argv))
          file_in = *argv;
        else
          opt_xusage(name, usage);
        break;
      case 4:
        if(*(++argv))
          {
            depth = atoi(*argv);
            depth = (depth>=10 && depth<=MINTER_DEPTH_MAX)?depth:10;
          }
        else
          opt_xusage(name, usage);
        break;
      default:
        cycle = atoi(*argv);
        break;
      }

  if(cycle>0)
    {
      result_p result = NULL;
      char *data = NULL;
      long length = opt_filter(file_in, &data);
      result = kh_compute(data, length, cycle, depth);
      result_view(result);
      result_destroy(result);
      free(data);
      exit(0);
    }
  else
    opt_xusage(name, usage);
}

/*========================================================================*/
