/*==========================================================================
//  Dcryptage du chiffrement de Vigenre
//  Projet TER, Matrise d'Informatique 1997,
//  Universit de Bordeaux 1, France,
//  Tous droits rservs.
//
//  de Maillard Luc, Montiton Frdric
//  Morreeuw Jean-Franois et Lompo Issa
//
//  mailto:morreeuw@emi.u-bordeaux.fr,dbv@komicom.remcomp.fr
//  http://www.emi.u_bordeaux.fr/~morreeuw/universite/TER
//
//  INTERFACE DU MODULE DECRYPTAGE DU CHIFFREMENT DE CAESAR (MONOALPHABET)
//
//========================================================================*/

#include <stdlib.h>
#include <stdio.h>
#include "define.h"
#include "shift.h"
#include "option.h"
#include "result.h"

#define OFFSET_DEPTH_MAX 200

static char *version="04/06/1997";
static char *option[]={"-h", "--help",
                       "-v", "--version",
                       "-f", "--infile",
                       "-d", "--depth",
                       "-p", "--path", NULL };
static int choice[]={1, 1, 2, 2, 3, 3, 4, 4, 5, 5};
static char *usage[]={"[-v] [-h] [-f FILENAME] [-d DEPTH] [-p PATH]", NULL,
                      "Search the offset of a file", "",
                      "  -f --infile    choose the file to analyse (default is STDIN)",
                      "  -d --depth     choose the depth of the search (default is 10)",
                      "  -p --path      choose the path for the language files (default is .)",
                      "  -h --help      display this help",
                      "  -v --version   output version information", NULL};

/*========================================================================*/

void
main(int argc, char **argv)
{
  char *name = argv[0];
  char *path = ".";
  char *file_in = NULL;
  int depth = 10;

  while(*(++argv))
    switch(opt_argument(*argv, option, choice))
      {
      case 1:
        opt_usage(name, usage);
        exit(0);
        break;
      case 2:
        opt_version(name, version);
        exit(0);
        break;
      case 3:
        if(*(++argv))
          file_in = *argv;
        else
          opt_xusage(name, usage);
        break;
      case 4:
        if(*(++argv))
          {
            depth = atoi(*argv);
            depth = (depth>=1 && depth<=OFFSET_DEPTH_MAX)?depth:10;
          }
        else
          opt_xusage(name, usage);
        break;
      case 5:
        if(*(++argv))
          path = *argv;
        else
          opt_xusage(name, usage);
        break;
      default:
        opt_xusage(name, usage);
        break;
      }

    {
      result_p result = NULL;
      char *data = NULL;
      long length = opt_filter(file_in, &data);
      short number = shift_install(path);

      if(number!=0)
        {
          short i;
          for(i=0; i<number; i++)
            printf("%.2d %s\n", i, shift_language(i));
          printf("\n");
        }
      else
        {
          printf("No language file in %s\n", path);
          exit(1);
        }

      result = shift_search(data, length, depth);
      result_view(result);
      shift_remove();
      result_destroy(result);

      free(data);
    }

  exit(0);
}

/*========================================================================*/
