/*==========================================================================
//  Module d'interface avec la ligne de commandes
//   1. opt_argument() utilise deux tableaux faisant la correspondance
//                     une option et un nombre la representant
//   2. opt_load()     lit le contenu du fichier en effacant les char nuls
//   3. opt_filter()   lit un fichier mais ne garde que les majuscules
//========================================================================*/

#ifndef OPTION_H
#define OPTION_H

#include "define.h"
#include "io.h"

extern int   opt_argument(char *word, char **option, int *choice);
extern void  opt_usage(char *name, char **usage);
extern void  opt_xusage(char *name, char **usage);
extern char *opt_basename(char *name);
extern void  opt_version(char *name, char *version);
extern long  opt_load(char *filename, char **data);
extern long  opt_filter(char *filename, char **data);
extern void  opt_save(char *filename, char *data, long length);

#endif
