/*==========================================================================
//  Structure des resultats
//========================================================================*/

#ifndef RESULT_H
#define RESULT_H

#include "define.h"

typedef struct result *result_p;

extern void     result_destroy(result_p result);
extern result_p result_create(int depth, short width);
extern int      result_insert(result_p result);
extern void     result_normalize(result_p result);
extern int      result_clean(result_p result);
extern void     result_map(result_p result, double (*function)(short *offset,
							       double quality,
							       short width,
							       void *argument),
			   void *argument);
extern void     result_sort(result_p result);
extern short *  result_newoffset(result_p result);
extern double * result_newquality(result_p result);
extern int      result_depth(result_p result);
extern short *  result_offset(result_p result, int index);
extern double * result_quality(result_p result, int index);
extern result_p result_join(result_p result1, short width1,
			    short start1, short join1,
			    result_p result2, short width2,
			    short start2, short join2);
extern void     result_view(result_p result);

#endif
