/*==========================================================================
//  Ce module gere des multi-ensembles ordonnes en autorisant les
//  normalisations sur le nombre d'insertion. Il fournit deux objets,
//  d'abord les multi-ensembles de chaines de caracteres, ensuite les
//  multi-ensembles de reels. Ce module est une sur-couche au module de
//  skiplist dsl permettant une abstraction des manipulations.
//========================================================================*/

#ifndef SET_H
#define SET_H

#include "dsl.h"
#include "io.h"

#define SET_DOUBLE 1
#define SET_STRING 2

typedef struct set *set;

extern set    set_create(int type);
extern double set_member(set set, void *key);
extern double set_insert(set set, void *key);
extern double set_select(set set, void *key, double value);
extern long   set_entry(set set);
extern set    set_addition(set destination, set origin);
extern void   set_normalize(set set);
extern void * set_forward(set set, void *key);
extern void   set_save(char *filename, set set);
extern void   set_destroy(set set);

#endif
