/*==========================================================================
//  Module de decryptage de chiffrements monoalphabetiques
//   1. shift_intall()         permet de lire les fichiers de langues
//   2. shift_search()         cherche les 'depth' meilleures solutions
//   3. shift_language()       recupere les noms des langues lues
//   4. shift_remove()         libere les fichiers de langues lus
//   5. shift_double2binary()  convertion d'un tableau de flottants
//========================================================================*/

#ifndef SHIFT_H
#define SHIFT_H

#include "define.h"
#include "ic.h"
#include "result.h"
#include "option.h"

#define LANGUAGE_MAX        16
#define LANGUAGE_DATA_BYTES  4

extern short    shift_install(char *path);
extern result_p shift_search(char *data, long length, int depth);
extern char *   shift_language(short index);
extern void     shift_remove(void);
extern void     shift_double2binary(double *double_table,
				    unsigned char *binary_table);

#endif
