/*==========================================================================
//  Dcryptage du chiffrement de Vigenre
//  Projet TER, Matrise d'Informatique 1997,
//  Universit de Bordeaux 1, France,
//  Tous droits rservs.
//
//  de Maillard Luc, Montiton Frdric
//  Morreeuw Jean-Franois et Lompo Issa
//
//  mailto:morreeuw@emi.u-bordeaux.fr,dbv@komicom.remcomp.fr
//  http://www.emi.u_bordeaux.fr/~morreeuw/universite/TER
//
//  Ce module d'outils pour l'interfaage HTML n'a pas t ralis pour
//  ce projet, mais utilis tel quel.
//
//========================================================================*/

#include <stdlib.h>
#include <stdio.h>
#include "util.h"

#define LF 10
#define CR 13


void 
getword(char *word, char *line, char stop) 
{
  int x = 0,y;
  for(x=0;((line[x]) && (line[x] != stop));x++)
    word[x] = line[x];
  
  word[x] = '\0';
  if(line[x]) ++x;
  y=0;
  
  while((line[y++] = line[x++]));
}

char *
makeword(char *line, char stop) 
{
  int x = 0;
  int y = 0;
  char *word = (char *) malloc(sizeof(char) * (strlen(line)+1));

  for(x=0; line[x] && line[x]!=stop; x++)
    word[x] = line[x];
  
  word[x] = '\0';

  if(line[x])
    ++x;

  while((line[y++] = line[x++]))
    ;
  return word;
}

char *
fmakeword(FILE *fp, char stop, int *cl) 
{
  int word_size = 1024;
  char *word = (char *) malloc(sizeof(char) * (word_size+1));
  int pos = 0;

  while(1) 
    {
      word[pos] = (char) fgetc(fp);

      if(pos==word_size) 
	{
	  word[pos+1] = '\0';
	  word_size+=1024;
	  word = (char *) realloc(word, sizeof(char) * (word_size+1));
        }

      --(*cl);

      if(word[pos]==stop || feof(fp) || !(*cl)) 
	{
	  word[ word[pos]!=stop? ++pos:pos ] = '\0';
	  return word;
        }

      ++pos;
    }
}

char 
x2c(char *what) 
{
  char digit;

  digit = (what[0] >= 'A' ? ((what[0] & 0xdf)-'A')+10 : (what[0]-'0'));
  digit *= 16;
  digit += (what[1] >= 'A' ? ((what[1] & 0xdf)-'A')+10 : (what[1]-'0'));
  return(digit);
}

void 
unescape_url(char *url) 
{
  int x, y;

  for(x=0, y=0; url[y]; ++x, ++y) 
    {
      if((url[x]=url[y]) == '%') 
	{
	  url[x] = x2c(&url[y+1]);
	  y+=2;
        }
    }
  url[x]='\0';
}

void 
plustospace(char *string) 
{
  int x;

  for(x=0; string[x] ;x++)
    if(string[x]=='+')
      string[x]=' ';
}

int 
rind(char *s, char c) 
{
    register int x;
    for(x=strlen(s) - 1;x != -1; x--)
      if(s[x] == c) return x;
    return -1;
  }

int 
getline(char *s, int n, FILE *f) 
{
  register int i=0;
  while(1) 
    {
      s[i] = (char)fgetc(f);
      
      if(s[i] == CR)
	s[i] = fgetc(f);
      
      if((s[i] == 0x4) || (s[i] == LF) || (i == (n-1))) 
	{
	  s[i] = '\0';
	  return (feof(f) ? 1 : 0);
        }
      ++i;
    }
}

void 
send_fd(FILE *f, FILE *fd)
{
  char c;
  
  while (1) 
    {
      c = fgetc(f);
      if(feof(f))
	return;
      fputc(c,fd);
    }
}

