/*==========================================================================
//  Dcryptage du chiffrement de Vigenre
//  Projet TER, Matrise d'Informatique 1997,
//  Universit de Bordeaux 1, France,
//  Tous droits rservs.
//
//  de Maillard Luc, Montiton Frdric
//  Morreeuw Jean-Franois et Lompo Issa
//
//  mailto:morreeuw@emi.u-bordeaux.fr,dbv@komicom.remcomp.fr
//  http://www.emi.u_bordeaux.fr/~morreeuw/universite/TER
//
//  INTERFACE DU MODULE DU CHIFFREMENT DE VIGENERE
//
//========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include "cipher.h"
#include "option.h"

static char *version="03/17/1997";
static char *option[]={"-h", "--help", "-v", "--version", "-a",
		       "--alpha", "-f", 
		       "--infile", "-o", "--output", NULL};
static int choice[]={1, 1, 2, 2, 3, 3, 4, 4, 5, 5};
static char *usage[]={"[-v] [-h] [-f FILENAME] [-o FILENAME]", 
                      "[-a MIN MAX] [-|+]PASSWORD", NULL,
                      "[De]cipher datas with PASSWORD",
                      "",
                      "  -f --infile   choose the file to cipher (default is STDIN)",
                      "  -o --output   save the result as a file (default is STDOUT)",
                      "  -a --alpha    select a range of characters (default is A-Z)",
                      "  -h --help     display this help",
                      "  -v --version  output version information", NULL};

/*========================================================================*/

void
main(int argc, char **argv)
{
  char *name = argv[0];
  char *file_in = NULL;
  char *file_out = NULL;
  char *password = NULL;
  int mode = 0;

  if(argc==1)
    opt_xusage(name, usage);
  while(*(++argv))
    switch(opt_argument(*argv, option, choice))
      {
      case 1:
        opt_usage(name, usage);
        exit(0);
        break;
      case 2:
        opt_version(name, version);
        exit(0);
        break;
      case 3:
        if(*(++argv) && *(argv+1))
          cipher_define(argv[0][0], argv[1][0]);
        else
          opt_xusage(name, usage);
        argv++;
        break;
      case 4:
        if(*(++argv))
          file_in = *argv;
        else
          opt_xusage(name, usage);
        break;
      case 5:
        if(*(++argv))
          file_out = *argv;
        else
          opt_xusage(name, usage);
        break;
      default:
        if((password=cipher_password(*argv, &mode))==NULL)
          opt_xusage(name, usage);
        break;
      }

  if(password)
    {
      char *data_in = NULL;
      char *data_out = NULL;
      long length = opt_load(file_in, &data_in);
      data_out = cipher_compute(password, data_in, length, mode);
      opt_save(file_out, data_out, length);
      free(data_in);
      free(data_out);
      exit(0);
    }
  else
    opt_xusage(name, usage);
}

/*========================================================================*/
