/*===================================================================
//  Ce module d'exception est construit autour du module initialement
//  ecrit en TD de MTP en Maitrise LMI 96-97. La modification
//  apportee permet l'utilisation simultanee des erreurs systemes.
//=================================================================*/

#ifndef XCEPT_H
#define XCEPT_H

#include <setjmp.h>

typedef char *xcept;

extern void  xcept_pop(void);
extern void  xcept_push(xcept exception);
extern int   xcept_search(xcept exception, char *message, char *m_error,
                                           char *name, unsigned int line);
extern void *xcept_jmp_buf(void);
extern void  xcept_uncaught(void);
extern char *xcept_format(void);



#if !(HAVE_STRERROR || !(__dest_os) || __dest_os == __be_os)
extern int sys_nerr;
extern char *sys_errlist[];
#define strerror(E) ((E)<sys_nerr?sys_errlist[(E)]:"bogus error number")
#endif



#define DEFINE_XCEPT(_EXCEPTION_) xcept _EXCEPTION_=(xcept)#_EXCEPTION_
#define USE_XCEPT(_EXCEPTION_)    extern xcept _EXCEPTION_

#define HANDLE(_EXCEPTION_, _E1_, _E2_)                \
  ((xcept_push(_EXCEPTION_),                           \
    !setjmp(xcept_jmp_buf()))                          \
    ? ((_E1_), xcept_pop())                            \
    : (xcept_pop(), (void) (_E2_)))

#define RAISE(_EXCEPTION_, _S1_, _S2_)                        \
  (xcept_search(_EXCEPTION_, _S1_, _S2_, __FILE__, __LINE__)  \
   ? longjmp(xcept_jmp_buf(), 1)                              \
   : xcept_uncaught())

#define VERIFY(_VARIABLE_)                                              \
  if(_VARIABLE_==NULL)                                                  \
  RAISE(fatal_XCEPT, #_VARIABLE_, "Cannot access a NULL pointer")



USE_XCEPT(last_XCEPT);
USE_XCEPT(fatal_XCEPT);

#endif
