#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/ToggleB.h>
#include <Xm/Text.h>
#include <Xm/MainW.h>
#include <Xm/CascadeB.h>
#include <Xm/MessageB.h> 
#include <Xm/PushB.h>
#include <Xm/SelectioB.h>
#include <Xm/FileSB.h>

#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "auto.h"
#include "cipher.h"
#include "option.h"
#include "malloc2.h"
#include "xcept.h"

#define WINDOW_WIDTH 40
#define ERROR_DIM 100

static char *xvig_filter(char *string);
static char *xvig_format(char *text);
static void  xvig_cipher(char *file_from, char *file_dest, char *file_with, short mode);
static void  xvig_break(char *file_from, char *dest);

/* prototype functions */
void quit_call(Widget, int); /*These are the real parameter declarations of a callback function : (Widget , XtPointer , XmFileSelectionBoxCallbackStruct *);*/
void file_call(Widget, int);
void edit_call(Widget, int);
void options_call(Widget, int);
void save_call(Widget , XtPointer, 
                   XmSelectionBoxCallbackStruct *);
void saveAs_call(Widget, XtPointer,
			    XmSelectionBoxCallbackStruct *);
void text1Changed_call(Widget , XtPointer *, 
            XmAnyCallbackStruct  *);
void text1On_call(Widget, XtPointer *, 
            XmAnyCallbackStruct  *);
void text2Changed_call(Widget , XtPointer *, 
            XmAnyCallbackStruct  *);
void text2On_call(Widget, XtPointer *, 
            XmAnyCallbackStruct  *);
void fCipherButt_call(Widget , XtPointer , 
                  XmPushButtonCallbackStruct *);
void fUncipherButt_call(Widget , XtPointer , 
                  XmPushButtonCallbackStruct *);
void fSearchButt_call(Widget , XtPointer , 
                  XmPushButtonCallbackStruct *);
void prevKeyBut1_call(Widget , XtPointer , 
                  XmPushButtonCallbackStruct *);
void saveKeyBut1_call(Widget , XtPointer , 
                  XmPushButtonCallbackStruct *);
void nextKeyBut1_call(Widget , XtPointer , 
                  XmPushButtonCallbackStruct *);
void prevKeyBut2_call(Widget , XtPointer , 
                  XmPushButtonCallbackStruct *);
void saveKeyBut2_call(Widget , XtPointer , 
                  XmPushButtonCallbackStruct *);
void nextKeyBut2_call(Widget , XtPointer , 
                  XmPushButtonCallbackStruct *);
void toggleFrom1or2_call(Widget , XtPointer , 
                     XmToggleButtonCallbackStruct *);
void toggleTo1or2_call(Widget , XtPointer , 
                     XmToggleButtonCallbackStruct *);
void ScrubDial(Widget, int);
void select_activate(Widget , XtPointer , 
                     XmFileSelectionBoxCallbackStruct *);
void cancel(Widget , XtPointer , 
            XmFileSelectionBoxCallbackStruct *);
void error_pop_up(char *);
void read_file(Widget, char *);
Widget whichTextWidget(void);
void untouchedFile(Widget text_w);
void setDataIn(Widget text_w);
void setNoData(Widget text_w);
void write_file(Widget, char *);
void copyFile(char *, char *);


/* globals */

/* widgets */
Widget top_wid, main_w, menubar, formFrame_w, formPane_w, formText_w;
Widget quit_w, file_w, edit_w, options_w, help_w;
Widget fastFuncBut_w, fCipherButt_w, fUncipherButt_w;
Widget fUncipherButt_w, fSearchButt_w, keyPane_w;
Widget keyDisplay1_w, keyDisplay2_w, textPane_w;
Widget formTog_w, toggleFrom1or2_w, text_w1, text_w2;
Widget toggleTo1or2_w, error_dialog, remove_w, getSaveAs_w;


char *filename1 = NULL;
char *filename2 = NULL;
char fileDisplayName1[FILENAME_MAX];
char fileDisplayName2[FILENAME_MAX];

char keyDisplayName1[FILENAME_MAX];
char keyDisplayName2[FILENAME_MAX];


String menu_elements[] = {"Quit", "File", "Edit", "Options"};
String quit_element[] = {"Quit"};
String file_elements[] = { "Open",  "Save", "Save as...", "Reload"};
String edit_elements[] = {"Clear"};
String options_elements[] = {"Encipher", "Decipher", "Search"};


/* WATCH OUT! The following are default settings, don't get careless with them */
/* boolean intepretation:
0 is for False
1 is for True */
int sourceWindow = 1;
int destinationWindow = 1;
int text1Changed = 0; /* this will be used by the save file option to determine whether a text1 has been modified. */
int dataInText1 = 0;
int text2Changed = 0; /* this will be used by the save file option to determine whether a text2 has been modified */
int dataInText2 = 0;
/* the following will tell the save file, save file as, clear, ... options on which window we are working on */
int onWindow1 = 0;  
int onWindow2 = 0;




/************************************************************************/
/*                    MIGHTY    VOID   MAIN   VOID                     */ 
/************************************************************************/
void
main(int argc, char **argv)

{   

    XtAppContext app;

    XmString quit_str, file_str, edit_str, options_str, open_str;
    XmString save_str, saveAs_str, reload_str, clearAll_str;
    XmString cipher_str, uncipher_str, findkeyword_str, xm_string1;

    int n;
    Arg args[20];

    tmpnam(fileDisplayName1);
    tmpnam(fileDisplayName2);
    tmpnam(keyDisplayName1);
    tmpnam(keyDisplayName2);


    /* Initialize toolkit */
    top_wid = XtVaAppInitialize(&app, "XVig", NULL, 0,
				&argc, argv, NULL, NULL );
 


    /* main window will contain a menu bar, two text windows, radio boxes and push buttons */      
    main_w = XtVaCreateManagedWidget("main_window",
                                   xmMainWindowWidgetClass,   top_wid,
				   XmNwidth, 700,         
                                   XmNheight, 580,
                                   NULL);


    /******* Start menu work segment ********/

/* Create a simple MenuBar that contains four menus */
    n = 0;
    quit_str = XmStringCreateLocalized(menu_elements[n]); n++;
    file_str = XmStringCreateLocalized(menu_elements[n]); n++;
    edit_str = XmStringCreateLocalized(menu_elements[n]); n++;
    options_str = XmStringCreateLocalized(menu_elements[n]); n++;
    
    menubar = XmVaCreateSimpleMenuBar(main_w, "menubar",
        XmVaCASCADEBUTTON, quit_str, 'Q',
        XmVaCASCADEBUTTON, file_str, 'F',
        XmVaCASCADEBUTTON, edit_str, 'E',
        XmVaCASCADEBUTTON, options_str, 'O',
        NULL);

/* finished with these, so free */
    XmStringFree(file_str);
    XmStringFree(edit_str);
    XmStringFree(options_str);


/* First menu is the quit menu -- callback is quit_call() */
    quit_w = XmVaCreateSimplePulldownMenu(menubar, "quit_menu", 0, (XtCallbackProc)  quit_call,
        XmVaPUSHBUTTON, quit_str, 'Q', NULL, NULL, NULL);

/* finished with this, so free */
    XmStringFree(quit_str);


/* Second menu is the file menu -- callback is file_call() */
    n = 0;
    open_str = XmStringCreateLocalized(file_elements[n]); n++;
    save_str = XmStringCreateLocalized(file_elements[n]); n++;
    saveAs_str = XmStringCreateLocalized(file_elements[n]); n++;
    reload_str = XmStringCreateLocalized(file_elements[n]); n++;

    file_w = XmVaCreateSimplePulldownMenu(menubar, "file_menu", 1,
        (XtCallbackProc) file_call,
        XmVaPUSHBUTTON, open_str, 'O'/*Meta key*/, NULL, NULL,
        XmVaPUSHBUTTON, save_str, 'S', NULL, NULL,
        XmVaPUSHBUTTON, saveAs_str, 's', NULL, NULL,
        XmVaPUSHBUTTON, reload_str, 'R', NULL, NULL,  NULL
				      );

/* finished with these, so free */
    XmStringFree(open_str);			 
    XmStringFree(save_str);
    XmStringFree(saveAs_str);
    XmStringFree(reload_str);


/* Third menu is the edit menu -- callback is edit_call() */
    n = 0;
    clearAll_str = XmStringCreateLocalized(edit_elements[n]); n++;
  
    edit_w = XmVaCreateSimplePulldownMenu(menubar, "edit_menu", 2, 
        (XtCallbackProc) edit_call,
	XmVaPUSHBUTTON, clearAll_str, 'C', NULL, NULL, NULL
				      );

/* finished with this, so free */
    XmStringFree(clearAll_str);


/* Fourth menu is the options menu -- callback is  options_call() */
    n = 0;
    cipher_str = XmStringCreateLocalized(options_elements[n]); n++;
    uncipher_str = XmStringCreateLocalized(options_elements[n]); n++;
    findkeyword_str = XmStringCreateLocalized(options_elements[n]); n++;

    options_w = XmVaCreateSimplePulldownMenu(menubar, "options_menu", 3, 
       (XtCallbackProc) options_call,
        XmVaPUSHBUTTON, cipher_str, 'E', NULL, NULL,
        XmVaPUSHBUTTON, uncipher_str, 'D', NULL, NULL,
        XmVaPUSHBUTTON, findkeyword_str, 'S', NULL, NULL, NULL
					 );

/* finished with these, so free */
    XmStringFree(cipher_str);
    XmStringFree(uncipher_str);
    XmStringFree(findkeyword_str);



/* manage menubar */
    XtManageChild(menubar);


    /***** Menu work segment done ********/


   /******* Start main window work segment ********/

/* define the main frame in the main window */
    formFrame_w = XtVaCreateManagedWidget("formFrame",
                xmFormWidgetClass, main_w,
                XmNfractionBase,     12,
                NULL);

/* define the pane frame in the main frame */
    formPane_w = XtVaCreateManagedWidget("pane",
                xmFormWidgetClass, formFrame_w,
                XmNfractionBase,     4,
		XmNtopAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
	        XmNrightAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_POSITION,
		XmNbottomPosition, 1,
                NULL);

/* define the display frame in the main frame */
   formText_w = XtVaCreateManagedWidget("formTexts",
                xmFormWidgetClass, formFrame_w,
                XmNfractionBase,     20,
                XmNtopAttachment, XmATTACH_POSITION,
                XmNtopPosition, 1,
		XmNbottomAttachment, XmATTACH_FORM,
	        XmNrightAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
                NULL);


   /******* Start Pane work segment ********/

/* creat fast-function-buttons widgets */

/* define fast-function-buttons frame in the pane frame */
   fastFuncBut_w = XtVaCreateManagedWidget( "fastFuncButtons",
      xmFormWidgetClass, formPane_w,
      XmNfractionBase,     3,
      XmNtopAttachment, XmATTACH_FORM,
      XmNbottomAttachment, XmATTACH_FORM,
      XmNleftAttachment, XmATTACH_FORM,
      XmNrightAttachment, XmATTACH_POSITION,
      XmNrightPosition, 3,
        NULL);

/* cipher button */
   fCipherButt_w = XtVaCreateManagedWidget("Encipher",
      xmPushButtonWidgetClass, fastFuncBut_w,
      XmNtopAttachment, XmATTACH_FORM, 
      XmNbottomAttachment, XmATTACH_FORM,
      XmNleftAttachment, XmATTACH_FORM,
      XmNrightAttachment, XmATTACH_POSITION,
      XmNrightPosition, 1,
      NULL);
   

/* uncipher button */  
   fUncipherButt_w = XtVaCreateManagedWidget("Decipher",
      xmPushButtonWidgetClass, fastFuncBut_w,
      XmNtopAttachment, XmATTACH_FORM, 
      XmNbottomAttachment, XmATTACH_FORM,
      XmNleftAttachment, XmATTACH_POSITION,
      XmNleftPosition, 1,
      XmNrightAttachment, XmATTACH_POSITION,
      XmNrightPosition, 2,
      				     
      NULL);

/* search button */
   fSearchButt_w = XtVaCreateManagedWidget("Search",
      xmPushButtonWidgetClass, fastFuncBut_w,
      XmNtopAttachment, XmATTACH_FORM, 
      XmNbottomAttachment, XmATTACH_FORM,
      XmNleftAttachment, XmATTACH_POSITION,
      XmNleftPosition, 2,
      XmNrightAttachment, XmATTACH_POSITION,
      XmNrightPosition,    3,
      NULL);

/* add callback functions to these buttons */
    
    XtAddCallback(fCipherButt_w, XmNactivateCallback, (XtCallbackProc) fCipherButt_call, NULL);
    XtAddCallback(fUncipherButt_w, XmNactivateCallback, (XtCallbackProc) fUncipherButt_call, NULL);
    XtAddCallback(fSearchButt_w, XmNactivateCallback, (XtCallbackProc) fSearchButt_call, NULL);




/* creat window redirection related widgets */

/* define the window redirection frame in the pane frame */
   formTog_w  = XtVaCreateManagedWidget("formToggle",
      xmFormWidgetClass, formPane_w,
      XmNfractionBase,     10,				
      XmNtopAttachment, XmATTACH_FORM,
      XmNbottomAttachment, XmATTACH_FORM,
      XmNleftAttachment, XmATTACH_POSITION,
      XmNleftPosition, 3,
      XmNrightAttachment, XmATTACH_FORM,
        NULL);

/* the toggle buttons */
   toggleFrom1or2_w = XtVaCreateManagedWidget("From window A[ ]/B[X]",
      xmToggleButtonWidgetClass, formTog_w,
      XmNindicatorSize, 18,
      XmNtopAttachment, XmATTACH_POSITION,
      XmNtopPosition, 1,
      XmNbottomAttachment, XmATTACH_POSITION,
      XmNbottomPosition, 4,
      XmNleftAttachment, XmATTACH_POSITION,
      XmNleftPosition, 1,
      XmNrightAttachment, XmATTACH_FORM,
      NULL);
        
    XtAddCallback(toggleFrom1or2_w, XmNvalueChangedCallback, 
                  (XtCallbackProc) toggleFrom1or2_call, NULL);
    
    toggleTo1or2_w = XtVaCreateManagedWidget("To window A[ ]/B[X]",
      xmToggleButtonWidgetClass, formTog_w,
      XmNindicatorSize, 18,
      XmNtopAttachment, XmATTACH_POSITION,
      XmNtopPosition, 6,
      XmNbottomAttachment, XmATTACH_POSITION,
      XmNbottomPosition, 9,
      XmNleftAttachment, XmATTACH_POSITION,
      XmNleftPosition, 1,
      XmNrightAttachment, XmATTACH_FORM,
      NULL);
        
    XtAddCallback(toggleTo1or2_w, XmNvalueChangedCallback, 
                  (XtCallbackProc) toggleTo1or2_call, NULL);
    


/* create keyword related widgets */

/* define keyword frame in the pane frame */
    keyPane_w = XtVaCreateManagedWidget( "keyPane",
      xmFormWidgetClass, formText_w,
      XmNfractionBase,     20,
      XmNtopAttachment, XmATTACH_FORM,
      XmNbottomAttachment, XmATTACH_POSITION,
      XmNbottomPosition, 2,
      XmNleftAttachment, XmATTACH_FORM,
      XmNrightAttachment, XmATTACH_FORM,
        NULL);


/* Create left key display area */  
  n=0;
  XtSetArg(args[n], XmNrows,      1); n++;
  XtSetArg(args[n], XmNcolumns,   128); n++;
  XtSetArg(args[n], XmNeditable,  True); n++;
  XtSetArg(args[n], XmNscrollHorizontal, True); n++;
  XtSetArg(args[n], XmNscrollVertical, False); n++;

/* WATCH OUT!! XmSINGLE_LINE_EDIT will not allow you to type carriage returns in your key's file text. If you want to use carriage returns in the key file, you should replace XmSINGLE_LINE_EDIT with XmMULTI_LINE_EDIT */
  XtSetArg(args[n], XmNeditMode,  XmSINGLE_LINE_EDIT); n++;

/* set positioning in keyPane */
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNleftPosition, 1); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNrightPosition, 9); n++;
 
  keyDisplay1_w = XmCreateScrolledText(keyPane_w, "keyDisplay1", 
                                  args, n);
  XtManageChild(keyDisplay1_w);



/* Create right key display area */  
  n=0;
  XtSetArg(args[n], XmNrows,      1); n++;
  XtSetArg(args[n], XmNcolumns,   128); n++;
  XtSetArg(args[n], XmNeditable,  True); n++;
  XtSetArg(args[n], XmNscrollHorizontal, True); n++;
  XtSetArg(args[n], XmNscrollVertical, False); n++;

/* WATCH OUT!! XmSINGLE_LINE_EDIT will not allow you to put carriage return in your key file text. If you want to use carriage return in the key file, you should replace XmSINGLE_LINE_EDIT with XmMULTI_LINE_EDIT */
  XtSetArg(args[n], XmNeditMode,  XmSINGLE_LINE_EDIT); n++;

/* set positioning in keyPane */
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNleftPosition, 11); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
  XtSetArg(args[n], XmNrightPosition, 19); n++;
  
  keyDisplay2_w = XmCreateScrolledText(keyPane_w, "keyDisplay2", 
                                  args, n);
  XtManageChild(keyDisplay2_w);


    /***** Pane  work segment done *******/


  /***** text Pane pane work segment *******/

/* Create text pane */
 textPane_w = XtVaCreateManagedWidget( "textPane",
      xmFormWidgetClass, formText_w,
      XmNfractionBase,     20,
      XmNtopAttachment, XmATTACH_POSITION,
      XmNtopPosition, 2,
      XmNbottomAttachment, XmATTACH_POSITION,
      XmNbottomPosition, 19,
      XmNleftAttachment, XmATTACH_FORM,
      XmNrightAttachment, XmATTACH_FORM,
        NULL);


/* Create ScrolledText number 1 */
    n=0; /* reset n */
    XtSetArg(args[n], XmNrows,      15); n++;
    XtSetArg(args[n], XmNcolumns,   40); n++;
    XtSetArg(args[n], XmNeditable,  True); n++;
    /* XtSetArg(args[n], XmNscrollHorizontal,  False); n++;*/
    XtSetArg(args[n], XmNeditMode,  XmMULTI_LINE_EDIT); n++;
    /* set positionning */
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
    XtSetArg(args[n], XmNleftPosition, 1); n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
    XtSetArg(args[n], XmNrightPosition, 9); n++;
    
    text_w1 = XmCreateScrolledText(textPane_w, "text_wid1", args, n);
    XtManageChild(text_w1);

    /* add callbacks to the text1 widget */

    /* be on the look out for any changes in this text window */
    XtAddCallback(text_w1, XmNvalueChangedCallback,
		  (XtCallbackProc) text1Changed_call, NULL);
    
    /* detect if the text1 window is the current active window */
    XtAddCallback(text_w1, XmNfocusCallback,
		  (XtCallbackProc) text1On_call, NULL);


/* Create ScrolledText number 2  */
    n=0; /* reset n */
    XtSetArg(args[n], XmNrows,      15); n++;
    XtSetArg(args[n], XmNcolumns,   40); n++;
    XtSetArg(args[n], XmNeditable,  True); n++;
    /* XtSetArg(args[n], XmNscrollHorizontal,  False); n++;*/
    XtSetArg(args[n], XmNeditMode,  XmMULTI_LINE_EDIT); n++;
    /* set positionning */
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
    XtSetArg(args[n], XmNleftPosition, 11); n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
    XtSetArg(args[n], XmNrightPosition, 19); n++;
    
    text_w2 = XmCreateScrolledText(textPane_w, "text_wid2", args, n);
    XtManageChild(text_w2);

    /* add callbacks to the text2 widget */

    /* be on the look out for any changes in this text window */
    XtAddCallback(text_w2, XmNvalueChangedCallback, (XtCallbackProc) text2Changed_call, NULL);
    
    /* detect if the text2 window is the current active window */
    XtAddCallback(text_w2, XmNfocusCallback, (XtCallbackProc) text2On_call, NULL);

    /***** Text Pane work segment done *******/


   /***** Double Text work segment done ********/

    

    XtRealizeWidget(top_wid);
    XtAppMainLoop(app);
}





/***********************************/
/*** Mighty Callback functions  ****/
/**********************************/


void quit_call(Widget w, int item_no) /* the quit option */
   /* w = menu item that was selected 
      item_no = the index into the menu */
{
  /* item_no == 0 */

  remove(keyDisplayName1);
  remove(keyDisplayName2);
  remove(fileDisplayName1);
  remove(fileDisplayName2);

  exit(0);
 }



void file_call(Widget w, int item_no)
{

  if ( item_no == 0) /* open file option */
    {
       Widget dialog, remove;
       XmString mask;
       Arg args[1];
       int n;	


/* Create the FileSelectionDialog */ 

/* this mask, right here, allows selection of any type of file */
/* put *.txt if you want text files */
       mask = XmStringCreateSimple("*"); 

       n=0;
       XtSetArg(args[n], XmNdirMask, mask); n++;

      dialog = XmCreateFileSelectionDialog(menubar, "select", args, n); /* never replace menubar with w */

      XtAddCallback(dialog, XmNokCallback, 
		    (XtCallbackProc) select_activate, NULL);
      XtAddCallback(dialog, XmNcancelCallback, 
		    (XtCallbackProc) cancel, NULL);

      remove = XmSelectionBoxGetChild(dialog, XmDIALOG_HELP_BUTTON);

      XtUnmanageChild(remove); /* delete HELP BUTTON */


      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);
    }

else if ( item_no == 1) /* save file option */
  {
      Widget text_w;
      char *text, *filename = NULL;
      char *realFilename = NULL;
      
      text_w = whichTextWidget();

      if(text_w == text_w1)
	{
	  if(filename1 == NULL)
	    {
	      error_pop_up("No Opened File");
	      return;
	    }

	  filename = fileDisplayName1;
	  realFilename = filename1;

	  if(filename1 == filename2)
	    {
	      write_file(text_w1, fileDisplayName2);
	      read_file(text_w2, fileDisplayName2);
	      untouchedFile(text_w2);
	    }

	  if(strcmp(filename1, "unknownFile1") == 0)
	    {
	      error_pop_up("File As No Name");
	      return;
	    }
	}
       
      else if(text_w == text_w2)
	{
	  if(filename2 == NULL)
	    {
	      error_pop_up("No Opened File");
	      return;
	    }
	  filename = fileDisplayName2;
	  realFilename = filename2;

	  if(filename2 == filename1)
	    {
	      write_file(text_w2, fileDisplayName1);
	      read_file(text_w1, fileDisplayName1);
	      untouchedFile(text_w1);
	    }

	  if(strcmp(filename2, "unknownFile2") == 0)
	    {
	      error_pop_up("File As No Name");
	      return;
	    }
	}

      write_file(text_w, filename); /* write in corresponding display buffer (refered to by : fileDisplayName1 or 2) */

      copyFile(realFilename, filename);
      untouchedFile(text_w);

    }
 else if(item_no == 2) /* save as option */
    {
      Widget saveAs_w, remove_w;
      XmString xm_string1;
      Arg args[2];
      int n;
      
/* the following is just used for function parameter passing filling */
      XtPointer client_data;
      XmPushButtonCallbackStruct *cbs;

/* label the dialog */
 
      xm_string1 = XmStringCreateLocalized("Enter File Name:");
  
    n = 0;
    XtSetArg(args[n], XmNselectionLabelString, xm_string1); n++;

    XmStringFree(xm_string1);

/* set up default button for activating callback */
    XtSetArg(args[n], XmNdefaultButtonType, 
                    XmDIALOG_OK_BUTTON); n++;

/* Create the save as dialog */ 
    saveAs_w = XmCreatePromptDialog(menubar, "saveAs", 
                                  args, n);

    XtAddCallback(saveAs_w, XmNokCallback, (XtCallbackProc) saveAs_call, 
                  NULL);
  
   /* Scrub Prompt Help Button */
    remove_w = XmSelectionBoxGetChild(saveAs_w, 
                      XmDIALOG_HELP_BUTTON);
   
    XtUnmanageChild(remove_w);  /* scrub HELP button */
    
    
    XtManageChild(saveAs_w);
    XtPopup(XtParent(saveAs_w), XtGrabNone);

    }

  else if ( item_no == 3) /* reload option */
    {
      Widget text_w;
      char *filename;

      text_w = whichTextWidget();
 
      if(text_w == text_w1)
	    filename = filename1;
      else filename = filename2;

      if(filename == NULL)
	    {
	      error_pop_up("No Opened File");
	      return;
	    }

      read_file(text_w, filename);
    }

}


void edit_call(Widget w, int item_no)
{

  Widget text_w;
  

  text_w = whichTextWidget();
  
  XmTextSetString(text_w, ""); /* clear all the window */
  XmTextSetInsertionPosition(text_w, 0); /* place insertion point at the upper right corner of window  */   
      
  setNoData(text_w); /* do not remove */
}


void options_call(Widget w, int item_no)
{
  /* the following is declared just for parameter passing filling */
  XtPointer client_data;
  XmPushButtonCallbackStruct *cbs;

  if ( item_no == 0) /* cipher function option */
    {
      fCipherButt_call(w, client_data, cbs);
    }
  else if ( item_no == 1) /* uncipher function option */
    {         
      fUncipherButt_call(w, client_data, cbs);
    }
  else if ( item_no == 2) /* find keyword function option */
    {
      fSearchButt_call(w, client_data, cbs);
    }

}



void fCipherButt_call(Widget w, XtPointer client_data, 
                  XmPushButtonCallbackStruct *cbs)
{
  FILE *fp;
  char *sourceFilename, *destinationFilename, *keyFilename;
  
  write_file(text_w1, fileDisplayName1);
  write_file(text_w2, fileDisplayName2);
  write_file(keyDisplay1_w, keyDisplayName1);
  write_file(keyDisplay2_w, keyDisplayName2);

  switch(sourceWindow)
    {
    case 1:
      sourceFilename = fileDisplayName1;
      keyFilename = keyDisplayName1;
      break;
    case 2:
      sourceFilename = fileDisplayName2;
      keyFilename = keyDisplayName2;
      break;
    }

  switch(destinationWindow)
    {
    case 1:
      destinationFilename = fileDisplayName1;
      filename1 = "unknownFile1";
      break;
    case 2:
      destinationFilename = fileDisplayName2;
      filename2 = "unknownFile2";
      break;
    }
  
  xvig_cipher(sourceFilename, destinationFilename, keyFilename, 1);

  read_file(text_w1, fileDisplayName1);
  read_file(text_w2, fileDisplayName2);
  read_file(keyDisplay1_w, keyDisplayName1);
  read_file(keyDisplay2_w, keyDisplayName2);
  return;
}

void fUncipherButt_call(Widget w, XtPointer client_data, 
                  XmPushButtonCallbackStruct *cbs)
{
  FILE *fp;
  char *sourceFilename, *destinationFilename, *keyFilename;
  
  write_file(text_w1, fileDisplayName1);
  write_file(text_w2, fileDisplayName2);
  write_file(keyDisplay1_w, keyDisplayName1);
  write_file(keyDisplay2_w, keyDisplayName2);

  switch(sourceWindow)
    {
    case 1:
      sourceFilename = fileDisplayName1;
      keyFilename = keyDisplayName1;
      break;
    case 2:
      sourceFilename = fileDisplayName2;
      keyFilename = keyDisplayName2;
      break;
    }

  switch(destinationWindow)
    {
    case 1:
      destinationFilename = fileDisplayName1;
      filename1 = "unknownFile1";
      break;
    case 2:
      destinationFilename = fileDisplayName2;
      filename2 = "unknownFile2";
      break;
    }
  
  xvig_cipher(sourceFilename, destinationFilename, keyFilename, -1);
  
  read_file(text_w1, fileDisplayName1);
  read_file(text_w2, fileDisplayName2);
  read_file(keyDisplay1_w, keyDisplayName1);
  read_file(keyDisplay2_w, keyDisplayName2);
  return;
}


void fSearchButt_call(Widget w, XtPointer client_data, 
                  XmPushButtonCallbackStruct *cbs)
{
  FILE *fp;
  char *sourceFilename, *newKeyFilename;
 
  write_file(text_w1, fileDisplayName1);
  write_file(text_w2, fileDisplayName2);
  write_file(keyDisplay1_w, keyDisplayName1);
  write_file(keyDisplay2_w, keyDisplayName2);

  if(sourceWindow == 2)
    {
      newKeyFilename = keyDisplayName2;
      sourceFilename = fileDisplayName2;
    }
  else
    {
      newKeyFilename = keyDisplayName1;
      sourceFilename = fileDisplayName1;
    }
  
  xvig_break(sourceFilename, newKeyFilename);

  read_file(text_w1, fileDisplayName1);
  read_file(text_w2, fileDisplayName2);
  read_file(keyDisplay1_w, keyDisplayName1);
  read_file(keyDisplay2_w, keyDisplayName2);
  return;
}



/* routine to remove a DialButton from a Dialog */

void
ScrubDial(Widget widget, int dial)
{  Widget remove;

   remove = XmMessageBoxGetChild(widget, dial);  
   XtUnmanageChild(remove);    
}

 
/* callback function for Prompt activate */

void
select_activate(Widget widget, XtPointer client_data, 
		XmFileSelectionBoxCallbackStruct *selection)
{  
/* this function is used to files */

  Widget text_w;
  char *filename = NULL;

  XmStringGetLtoR(selection->value, 
		    XmSTRING_DEFAULT_CHARSET, &filename);
   
  text_w = whichTextWidget();
 
  if(text_w == text_w1)
    {
      filename1 = filename;
      copyFile(fileDisplayName1, filename);
    }
  else if(text_w == text_w2)
    {
      filename2 = filename;
      copyFile(fileDisplayName2, filename);
    }

  read_file(text_w, filename);

  cancel(widget,client_data, selection ); /* close the window */ 
  
}

 
void
cancel(Widget widget, XtPointer client_data, 
       XmFileSelectionBoxCallbackStruct *selection)
{
  XtUnmanageChild(widget);  /* undisplay widget */    
}


void
read_file(Widget  text_wid, char *filename)
{
  FILE *fp = NULL;
  char  *text, errorMessage[ERROR_DIM];
  struct stat statb;
  
  if ( (fp = fopen(filename, "r")) == NULL)
    { 
      strcpy(errorMessage, "FILE OPEN ERROR: Can't open ");
      strcat(errorMessage, filename);
      error_pop_up(errorMessage);
      return;
    }
  
/* check if file is a regular text file and open it */
  
  if ( (stat(filename, &statb) == -1) ) 
    {   
      strcpy(errorMessage, "Cannot Access File Stats For ");
      strcat(errorMessage, filename);
      error_pop_up(errorMessage);
      if(fp != NULL)
	fclose(fp);
      return;
    }
  
/* Map file text in the TextWidget */    
  
  if (!(text = XtMalloc((unsigned)(statb.st_size+1)))) 
    {   
      strcpy(errorMessage, "Cannot Alloc Enough Space For File: ");
      strcat(errorMessage, filename);
      error_pop_up(errorMessage);
      if(fp != NULL)
	fclose(fp);
      return;
    }
  
  if (fread(text, sizeof(char), statb.st_size+1, fp)==-1)
    {   
      strcpy(errorMessage, "FILE READ ERROR: ");
      strcat(errorMessage, filename);
      error_pop_up(errorMessage);
      if(fp != NULL)
	fclose(fp);
      return;
    }
  
  text[statb.st_size] = '\0'; /* be sure to NULL-terminate */
  
/* insert file contents in TextWidget */
  XmTextSetString(text_wid, text);
  
  fclose(fp);
  XtFree(text);
  
  if((text_wid == text_w1) || (text_wid == text_w2))
    {
      untouchedFile(text_wid);  /* consider file as untouched */ 
      setDataIn(text_wid);      /* text display is no longer empty */ 
    }
}



void saveAs_call(Widget widget, XtPointer client_data,
		 XmSelectionBoxCallbackStruct *selection)
{   
/* save as convention : the new file that results from the save as is not the active file in the text window */

  Widget text_w;
  XmString xm_string;
  char *newFilename = NULL;
    
  text_w = whichTextWidget();

/* compose filename output string */
/* selection->value holds XmString entered in prompt dialog pop-up window */
   XmStringGetLtoR(selection->value, 
		    XmSTRING_DEFAULT_CHARSET, &newFilename);

  write_file(text_w, newFilename); 
  
  if( (text_w == text_w1) && (newFilename == filename2) )
    {
      copyFile(fileDisplayName2, newFilename);
      read_file(text_w2, fileDisplayName2);
    }
  else if( (text_w == text_w2) && (newFilename == filename1) )
    {
      copyFile(fileDisplayName1, newFilename);
      read_file(text_w2, fileDisplayName1);
    }
}



void toggleFrom1or2_call(Widget w, XtPointer client_data, 
                     XmToggleButtonCallbackStruct *state)
{
  
  if(state->set) /* window 2 selected */
    sourceWindow = 2;
  else /* work with window 1 */
    sourceWindow = 1;
}


void toggleTo1or2_call(Widget w, XtPointer client_data, 
                     XmToggleButtonCallbackStruct *state)
{
  if(state->set) /* window 2 is destination */
      destinationWindow = 2;
  else /* work with window 1 */ 
      destinationWindow = 1;
}


void text1Changed_call(Widget w, XtPointer *client_data, 
            XmAnyCallbackStruct  *cbs)
{
/* a change in the text has been made */
  if(text1Changed == 0)
    {
      text1Changed = 1;
    }
  setDataIn(text_w1);
}

void text1On_call(Widget w, XtPointer *client_data, 
            XmAnyCallbackStruct  *cbs)
{
/* Window number 1 is the current active window */
  if(onWindow1 == 0)
    {
      onWindow1=1;
      onWindow2=0;
    }
}

void text2Changed_call(Widget w, XtPointer *client_data, 
            XmAnyCallbackStruct  *cbs)
{
/* a change in the text has been made */
  if(text2Changed == 0)
    {
      text2Changed = 1;
    }
  setDataIn(text_w2);
}


void text2On_call(Widget w, XtPointer *client_data, 
            XmAnyCallbackStruct  *cbs)
{
/* Window number 2 is the current active window */
  if(onWindow2 == 0)
    {
      onWindow2=1;
      onWindow1=0;
    }
}


Widget whichTextWidget(void)
{
/* detirmine on which window to open file */
  /* default opening on window 1 */
  if( ((onWindow1 == 0) && (onWindow2 == 0)) || (onWindow1 == 1) )
    return text_w1;
 else return text_w2;
}


void untouchedFile(Widget text_w)
{
  if(text_w == text_w1)
    text1Changed = 0;
  else
    text2Changed = 0;
}


void setDataIn(Widget text_w)
{
  if(text_w == text_w1)
    dataInText1 = 1;
  else
    dataInText2 = 1;
}

void setNoData(Widget text_w)
{
  if(text_w == text_w1)
    dataInText1 = 0;
  else
    dataInText2 = 0;
}


void write_file(Widget text_w, char *filename)
{
  FILE *fp;
  char errorMessage[ERROR_DIM];

  if(XmTextGetString(text_w)==NULL)
    return;

 if ( (fp = fopen(filename, "w")) == NULL)
   { 
     strcpy(errorMessage, "FILE OPEN ERROR: ");
     strcat(errorMessage, filename);
     error_pop_up(errorMessage);
     return;
   }
       
 fprintf(fp, XmTextGetString(text_w));

/* free memory */
 fclose(fp);

}


void copyFile(char *destination, char *source)
{
  FILE *sfp, *dfp;
  char errorMessage[ERROR_DIM];
  int c;
  
  if( (sfp = fopen(source, "r")) == NULL )
    {
      strcpy(errorMessage, "FILE OPEN ERROR: Can't open ");
      strcat(errorMessage, source);
      error_pop_up(errorMessage);
      return;
    }
  if( (dfp = fopen(destination, "w")) == NULL )
    {
      strcpy(errorMessage, "FILE OPEN ERROR: Can't open ");
      strcat(errorMessage, destination);
      error_pop_up(errorMessage);
      return;
    }
  
  while( (c = fgetc(sfp)) != EOF)
    {
      putc(c, dfp);
    }

  close(sfp);
  close(dfp);

  return;
}


void error_pop_up(char *errorMessage)
{

  XmString xm_string;
  Arg args[2];

/* Label the dialog */
  xm_string = XmStringCreateLocalized(errorMessage);
  XtSetArg(args[0], XmNmessageString, xm_string);
/* set up default button for ok callback */
  XtSetArg(args[1], XmNdefaultButtonType, XmDIALOG_OK_BUTTON);

/* Create the ErrorDialog */

  error_dialog = XmCreateErrorDialog(menubar, "errorDialog", args, 2);

  ScrubDial(error_dialog, XmDIALOG_HELP_BUTTON);
  ScrubDial(error_dialog, XmDIALOG_CANCEL_BUTTON);

  XmStringFree(xm_string);

  XtManageChild(error_dialog);
  XtPopup(XtParent(error_dialog), XtGrabNone);

}






char *xvig_filter(char *string)
{
  char *newstring = NULL;
  int length = 0;
  int i, j;

  if(string==NULL)
    return "";
  length = strlen(string);
  newstring = (char *) malloc(length+1);
  newstring[length]='\0';
  for(i=0, j=0; i<length; i++)
    {
      if(string[i]>='A' && string[i]<='Z')
	newstring[j++]=string[i];
      else if(string[i]>='a' && string[i]<='z')
	newstring[j++]=string[i]-'a'+'A';
      else switch(string[i])
	{
	case '':
	case '':
	case '':
	case '':
	  newstring[j++]='I';
	  break;
	case '':
	case '':
	case '':
	case '':
	  newstring[j++]='E';
	  break;
	case '':
	case '':
	case '':
	case '':
	  newstring[j++]='A';
	  break;
	case '':
	case '':
	case '':
	case '':
	  newstring[j++]='O';
	  break;
	case '':
	case '':
	case '':
	case '':
	  newstring[j++]='U';
	  break;
	case '':
	case '':
	  newstring[j++]='Y';
	  break;
	case '':
	  newstring[j++]='C';
	  break;
	default:
	  break;
	}
    }
  newstring[j]='\0';
  return newstring;
}

char *
xvig_format(char *text)
{
  long i, j;
  long new_size = strlen(text)+strlen(text)/WINDOW_WIDTH;
  char *new_text = (char *) malloc(new_size+1);
  
  for(i=0, j=0; i<new_size; i++)
    if((i+1)%(WINDOW_WIDTH+1)==0)
      new_text[i]='\n';
    else
      new_text[i]=text[j++];
  new_text[i]='\0';
  
  return new_text;
}


void
xvig_cipher(char *file_from, char *file_dest, char *file_with, short mode)
{
  int xcept = 0x00;
  char *load_text = NULL;
  char *load_pass = NULL;
  char *old_text = NULL;
  char *password = NULL;
  char *new_text = NULL;
  char *save_new = NULL;
  char *save_old = NULL;

  HANDLE(fatal_XCEPT, opt_load(file_from, &load_text), xcept|=0x01);
  HANDLE(fatal_XCEPT, opt_load(file_with, &load_pass), xcept|=0x02);

  switch(xcept)
    {
    case 0x01:
      free2(load_pass);
      break;
    case 0x02:
      free2(load_text);
      break;
    case 0x00:
      old_text = xvig_filter(load_text);
      password = xvig_filter(load_pass);

      save_old = xvig_format(old_text);
      opt_save(file_from, save_old, strlen(save_old));
      opt_save(file_with, password, strlen(password));

      if(strlen(old_text)!=0 && strlen(password)!=0)
	{
	  new_text = cipher_compute(password, old_text, strlen(old_text), mode);
	  save_new = xvig_format(new_text);
	  opt_save(file_dest, save_new, strlen(save_new));
	  free2(new_text);
	  free(save_new);
	}

      free2(load_text);
      free2(load_pass);
      free(old_text);
      free(password);
      free(save_old);
      break;
    default:
      break;
    }
  
  return;
}

void
xvig_break(char *file_from, char *file_dest)
{
  int xcept = 0x00;
  char *load_text = NULL;
  char *new_text = NULL;
  char *save_new = NULL;
  char **password = NULL;

  HANDLE(fatal_XCEPT, opt_load(file_from, &load_text), xcept|=0x01);
  HANDLE(fatal_XCEPT, auto_install("."), xcept|=0x02);

  switch(xcept)
    {
    case 0x00:
      new_text = xvig_filter(load_text);
      save_new = xvig_format(new_text);
      opt_save(file_from, save_new, strlen(save_new));

      if(strlen(new_text)!=0)
	{    
	  HANDLE(fatal_XCEPT,
		 password = auto_decipher(new_text, strlen(new_text), 1, 20),
		 xcept|=0x04);
	  if(!(xcept&0x04))
	    {
	      opt_save(file_dest, password[0], strlen(password[0]));
	      free2(password[0]);
	      free2(password[1]);
	    }
	}

      free2(load_text);
      free(new_text);
      free(save_new);
    case 0x01:
      auto_remove();
      break;
    case 0x02:
      free2(load_text);
      error_pop_up("No language file");
      break;
    default:
      break;
    }
  
  return;
}
